import scrapy

#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=3 -a day=22

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
    return TAG_RE.sub('', text)

class NoticiasItem(scrapy.Item):
    title = scrapy.Field()
    text = scrapy.Field()
    date = scrapy.Field()
    location = scrapy.Field()
    author = scrapy.Field()
    topic = scrapy.Field()
    url = scrapy.Field()

class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		self.year = getattr(self, 'year', None)
		self.month = getattr(self, 'month', None)
		self.day = getattr(self, 'day', None)
		self.baseURL='http://www.desdeelbalcon.com/'+self.year+'/'+self.month+'/'+self.day
		urls = [
			self.baseURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)

	def parse(self, response):
		pagination = response.xpath('//div[@id="content"]/div[3]/a/@href').extract()
		if ( len(pagination) > 0 ):
			pagination = pagination[-2].strip('/')
			pages = int(pagination[pagination.rfind('/')+1:])
			for page in range(0, pages):
				if ( page == 0 ):
					yield scrapy.Request(url=response.url, callback=self.parse_page, dont_filter=True)
				else:
					yield scrapy.Request(url=response.url+"/page/"+str(page+1), callback=self.parse_page)
		else:
			yield scrapy.Request(url=response.url, callback=self.parse_page, dont_filter=True)

	def parse_page(self, response):
		item = NoticiasItem()
		for post in response.xpath('//ul[@class="archivepost"]/li'):
			item['date'] = self.year+'-'+self.month.zfill(2)+'-'+self.day.zfill(2)
			item['topic'] = post.xpath('./p/a/text()').extract()
			request = scrapy.Request(url=post.xpath('./h2/a/@href').extract_first(), callback=self.parse_item)
			request.meta['item'] = item
			yield request

	def parse_item(self, response):
		text = ''
		item = response.meta['item']
		item['title'] = response.xpath('//h1[@class="post entry-title"]/a/text()').extract_first()
		for paragraph in response.xpath('//div[@itemprop="text"]/p').extract():
			text += remove_tags(paragraph) + '\n'
		item['text'] = text
		item['url'] = response.url
		print item['title']
		yield item

