import scrapy

#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=03 -a day=22

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
	return TAG_RE.sub('', text)

class NoticiasItem(scrapy.Item):
    title = scrapy.Field()
    text = scrapy.Field()
    date = scrapy.Field()
    location = scrapy.Field()
    author = scrapy.Field()
    topic = scrapy.Field()
    url = scrapy.Field()

class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		self.year = getattr(self, 'year', None)
		self.month = getattr(self, 'month', None)
		self.day = getattr(self, 'day', None)
		self.baseURL='http://www.yucatanalminuto.com'
		urls = [
			self.baseURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)

	def parse(self, response):
		for menu in response.css("center").css("td").css("a::attr(href)").extract():
			if ( menu != '/' ):
				yield scrapy.Request(url=response.url+menu, callback=self.parse_pagination)

	def parse_pagination(self, response):
		pagination = response.xpath('//div[@id="color_seccion"]/div[1]/p/text()').extract()
		if ( len(pagination) > 0 ):
			pagination = remove_tags(pagination[1])
			pages = int(pagination[16:])
			for page in range(0, pages):
				if ( page == 0 ):
					yield scrapy.Request(url=response.url, callback=self.parse_page, dont_filter=True)
				else:
					yield scrapy.Request(url=response.url[:-1]+str(page+1), callback=self.parse_page)
		else:
			yield scrapy.Request(url=response.url, callback=self.parse_page, dont_filter=True)
	
	def parse_page(self, response):
		item = NoticiasItem()
		for post in response.xpath('//a[@class="lista_noticia"]'):
			date = post.css('div.pad5').css('p.sec_autor2::text').extract_first()
			if ( self.year+'-'+self.month+'-'+self.day == date[21:31] ):
				item['date'] = date[21:]
				item['topic'] = response.xpath('//div[@id="color_seccion"]/h1/text()').extract_first()
				request = scrapy.Request(url=self.baseURL+post.css('::attr(href)').extract_first(), callback=self.parse_item)
				request.meta['item'] = item
				yield request

	def parse_item(self, response):
		text = ''
		item = response.meta['item']
		item['title'] = response.css("td").css("h1.noticia_titulo::text").extract_first()
		for paragraph in response.css('div.noticia_contenido').css('p').extract():
			text += remove_tags( paragraph ) + '\n'
		item['text'] = text
		item['url'] = response.url
		print item['title']
		yield item